#include <conio.h>
#include <stdio.h>
#include <math.h>
#include <dos.h>

#include <crt.h>
#include <dtypes.h>
#include <vga.h>
#include <mouse.h>

BYTE Base_data[] = {0x00,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x00,
		    0x01,0x01,0x01,0x01,0x01,0x02,0x02,0x02,0x02,0x02,0x02,0x01,0x01,0x01,0x01,0x01,
		    0x01,0x01,0x01,0x01,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x01,0x01,0x01,0x01,
		    0x01,0x01,0x01,0x01,0x01,0x02,0x02,0x02,0x02,0x02,0x02,0x01,0x01,0x01,0x01,0x01,
		    0x00,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x00};

BYTE Ball_data[] = {0x00,0x04,0x04,0x04,0x00,
		    0x04,0x04,0x04,0x04,0x04,
		    0x04,0x04,0x04,0x04,0x04,
		    0x04,0x04,0x04,0x04,0x04,
		    0x00,0x04,0x04,0x04,0x00};

struct BaseT {
  int sizeX, sizeY;
  int posX, posY;
  BYTE *data;
} Base = {16,5, 0,185, (BYTE *)&Base_data};

struct BallT {
  int size;
  int posX, posY;
  int dir, vel;
  BYTE *data;
} Ball = {5, 100,30, 300,2, (BYTE *)&Ball_data};

VirtualScreen *vir1 = new VirtualScreen();

void updateCord() {
  mouse_getStatus();
  Base.posX = mouseInfo.xPos;
}

void drawBase() {
  int i,j;
  BYTE col;
  for (j=0;j<Base.sizeY;j++)
    for (i=0;i<Base.sizeX;i++) {
      col = *(Base.data+j*Base.sizeX+i);
      if (col) vir1->putPixel(Base.posX+i,Base.posY+j,col);
    }
}

char ballOnBaseY(int newpx, int newpy) {
  char onX = newpx+Ball.size>=Base.posX && newpx<=Base.posX+Base.sizeX;
  char onY = newpy+Ball.size>Base.posY && newpy<=Base.posY+Base.sizeY;
  return(onY && onX);
}

char ballOnBaseX() {
 /* char onY = Ball.posY+Ball.size>=Base.posY && Ball.posY <= Base.posY+Base.sizeY;
  return((Ball.posX+Ball.size>=Base.posX || Ball.posX<=Base.posX+Base.sizeX)&& onY);
  */ return(0);
}

void drawBall() {
  int i,j, npx,npy;
  BYTE col;
  npx = Ball.posX + cos(Ball.dir*M_PI/180)*Ball.vel;
  npy = Ball.posY + sin(Ball.dir*M_PI/180)*Ball.vel;
  if (npx<=0 || (npx+Ball.size)>319) {
    Ball.dir = (540-Ball.dir)%360;
    npx = Ball.posX + cos(Ball.dir*M_PI/180+M_PI_2)*Ball.vel;
  }
  if(npy<0 || (npy+Ball.size)>200 || ballOnBaseY(npx,npy)) {
    Ball.dir = (360-Ball.dir)%360;
    npy = Ball.posY + sin(Ball.dir*M_PI/180)*Ball.vel;
  }
  Ball.posX = npx;
  Ball.posY = npy;
  mouse_getStatus();
  for (j=0;j<Ball.size;j++)
    for (i=0;i<Ball.size;i++) {
      col = *(Ball.data+j*Ball.size+i);
      if (col) vir1->putPixel(Ball.posX+i,Ball.posY+j,col);
    }
}

void main() {
  crt_init();
  crt_setVideoMode(0x13);

  randomize();
  mouse_reset();
  mouse_setRange(0,0,319-Base.sizeX,199);
  mouse_setPos(160,0);

  vir1->clear(0);
  vir1->show();

  while (!mouseInfo.rightButton) {
    updateCord();
    drawBase();
    drawBall();
    vir1->show();
    vir1->clear(3);
    delay(8);
  }

  delete vir1;
  crt_restoreVideoMode();
}