#ifdef W3D_DECL
  #error W3d declarations already included.
#endif
#define W3D_DECL

struct point2Ds {
  int x,y;
};
#define SIZE_P2D 4

struct point3Ds {
  double x,y,z;
};
#define SIZE_P3D 24

struct edge {
  int a,b;
};
#define SIZE_EDG 4

struct object3Ds {
  char *name;
  int cNodes;
  int cEdges;
  point3Ds *nodes;
  edge *edges;
};
#define SIZE_OBJ 10

class wld_p {
  public:
  int sizeX,sizeY,sizeZ;  // size of the world
  int meX,meY,meZ;        // my position
  int perspective;
};

class obj_p {
  public:
  wld_p *parentWld;
};

class pnt_p {
  public:
  obj_p *parentObj;
};