/*  calculates an approximated square root  */
#include <conio.h>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <time.h>

#pragma option -1
#pragma warn -rvl

void tobin(int a) {
  int i;
  for (i=15; i>=0; i--) {
    printf("%i", (a>>i)&1);
  }
  printf("\n");
}

int sqrt_i2a(int n) {
  int res = 0;
  asm {
    mov  bx, n
    cmp  bx, 0
    jle  endfunc
    xor  dx, dx // dx = resto
    mov  cl, 8
  } loop1: asm {
      rol  bx,2
      mov  ax, bx
      and  ax, 3
      shl  dx, 2
      or   dx, ax // resto = 4*resto + ...
      shl  res, 1
      mov  ax, res
      shl  ax, 1
      or   ax, 1
      cmp  ax, dx
      ja   zero
      sub  dx, ax
      or   res, 1
    } zero: asm {
    dec  cl
    jnz  loop1
    } endfunc: asm {
    mov  ax, res
  }
}


long sqrt_i4a(long n) {
  asm {
    push  di
    db 0x66; xor  di, di
    db 0x66; mov  bx, word ptr n
    db 0x66; cmp  bx, 0
    jle  endfunc
    db 0x66; xor  dx, dx
    mov  cl, 16
  } loop1: asm {
      db 0x66; rol bx,2
      mov  al, bl
      and  al, 3
      db 0x66; shl dx,2
      or   dl, al
      db 0x66; shl  di, 1
      db 0x66; mov  ax, di
      db 0x66; shl  ax, 1
      or   al, 1
      db 0x66; cmp  ax, dx
      ja   zero
      db 0x66; sub  dx, ax
      or   di, 1
    } zero: asm {
    dec  cl
    jnz  loop1
    } endfunc: asm {
    mov  ax, di
    db 0x66; shr  di, 16
    mov  dx, di
    pop  di
  }
}

template <class T>
T sqrt_i(T n) {
  T nt, resto = 0, res = 0;
  register char pos;

  if (n < 0) return(0);
  for (pos=sizeof(T)*8-2; pos>=0; pos-=2) {
    resto = (resto<<2) + ((n>>pos)&3);
    res <<= 1;
    nt = (res<<1) | 1;
    if (nt <= resto) {
      resto -= nt;
      res |= 1;
    }
  }
  return(res);
}


void main() {
  clrscr();

  srand(424);
  long counter;
  time_t t1,t2;

  long a = 5177L*5177L+242;
  //tobin(56);
  printf("radice di %li  %li  %li\n", a, sqrt_i(a), sqrt_i4a(a));

  /*counter = 0;
  t1 = time(0);
  do {
    int c,b = rand();
    c = sqrt(b);
    counter++;
  } while (!kbhit());
  getch();
  t2 = time(0);
  printf("Velocit: %i\n", counter/(long)(t2-t1));

  counter = 0;
  t1 = time(0);
  do {
    int c,b = rand();
    c = intsqrt_a(b);
    counter++;
  } while (!kbhit());
  getch();
  t2 = time(0);
  printf("Velocit: %i\n", counter/(long)(t2-t1));*/


  getch();
}