#include <conio.h>
#include <dos.h>
#include <crt.h>
#include <vga.h>
#include <vgapal.h>

#include "bmp.cpp"
char fname[100];
int c;

#define NOSOUND

#define MAXSTEPY   4
#define MAXSTEPX   3
#define MAXDEV     2
#define MAXSEP     2
#define MAXSEPTOT  10

#define RAIN    150

VirtualScreen *screen;
pal256 pal;

typedef struct {
  int x,y,
      stepx,stepy,
      dev;
  int counter,
      life;
} SHOCK;

void doLandscape(int light, int xpos) {
  char savedm = screen->drawMode;
  BYTE col1, col2, col3;

  screen->drawMode = DM_NORMAL;
  if (light) {
    pal_invert(&pal, 0,255);
    pal_outAll(&pal);
    delay(20);
    pal_invert(&pal, 0,255);
    pal_outAll(&pal);
    if (xpos < 150) {
      col1 = 255;
      col2 = 200;
      col3 = 100;
    } else {
      if (xpos < 200) {
        col1 = 200;
        col2 = 255;
        col3 = 200;
      } else {
        col1 = 100;
        col2 = 200;
        col3 = 255;
      }
    }
  } else {
    col1 = col2 = col3 = 50;
  }
  screen->fCircle(80,320, 150, col1);
  screen->fCircle(180,350, 170, col2);
  screen->fCircle(320,300, 130, col3);
  screen->drawMode = savedm;
}

void doShock(SHOCK *prec) {
  SHOCK now;
  int i,j, sx,a,old, rnd;
  static int countsep;

  if (prec == NULL) {
    now.x = rand()%VGA_WIDTH;
    now.y = 0;
    now.stepy = rand()%max(1,MAXSTEPY)+1;
    now.stepx = rand()%min(MAXSTEPX,now.stepy+1)+1;
    now.dev = rand()%(MAXDEV*2+1)-MAXDEV;
    now.counter = 0;
    now.life = VGA_HEIGHT*2;
    countsep = 0;
  } else {
    now = *prec;
    now.life = rand()%((MAXSEPTOT-countsep)*50+1);
    countsep++;
  }

  if (now.counter >= MAXSEP) return;
  if (countsep >= MAXSEPTOT) return;

  a = now.x;
  for (j=now.y; (j<VGA_MAXY) && (j>=0) && (now.life >= 0); j+=now.stepy, now.life--) {
    rnd = rand();
    old = a;
    if ((now.stepx*2+1+now.dev) > 1) a = a+rnd%(now.stepx*2+1+now.dev)-now.stepx;
    else a = a+rnd%(now.stepx*2+1)-now.stepx;
    if (rnd%20 == 1) {
      now.stepy = max(1, min(now.stepy+rnd%5-2, MAXSTEPY));
      now.stepx = max(1, min(now.stepx+rnd%5-2, MAXSTEPX));
      now.dev = rand()%(MAXDEV+1)-MAXDEV/2;
    }
    if (rnd%100 == 1) {
      SHOCK next = now;
      next.x = a;
      next.y = j;
      next.dev = (now.dev==0)?(rand()%(MAXDEV*2+1)-MAXDEV):-now.dev;
      next.counter++;
      doShock(&next);
    }
    screen->line(old,j-now.stepy, a,j, 220);
  }
  if (now.counter == 0) doLandscape(1,a);
#ifndef NOSOUND
  sound(500);
  delay(5);
  sound(1000);
  delay(10);
  sound(1500);
  delay(20);
  nosound();
#endif
}

void doRain() {
  int i, x,y;
  static int wind = 0;

  for (i=0; i<RAIN; i++) {
    x = rand()%VGA_WIDTH;
    y = rand()%VGA_HEIGHT;
    screen->putPixel(x, y, rand()%100+50);
    screen->putPixel(x+wind, y+1, rand()%100+100);
    screen->putPixel(x+wind*2, y+2, rand()%100+150);
  }
  if (rand()%10 == 1) wind = max(-2, min(wind+(rand()%3-1),2));
#ifndef NOSOUND
  sound(20*abs(wind*wind*wind*wind*RAIN/10+1));
  delay(2);
  nosound();
#endif
}

void move1(VGACOORD x, VGACOORD y, VGACOORD *nx, VGACOORD *ny) {
  *nx = x+rand()%3-1;
  *ny = y+rand()%3-1;
}

void main() {
  crt_init();
  crt_setVideoMode(0x13);
  screen = new VirtualScreen();
  screen->clear(0);

  pal_setGradient(&pal, 0,127, 0,0,5, 10,20,50);
  pal_setGradient(&pal, 127,255, 10,20,50, 60,60,63);
  pal_outAll(&pal);

  randomize();
  c = 0;
  do {
    doRain();
    doLandscape(0, -1);
    screen->drawMode = DM_ADD;
    if (rand()%16 == 1) doShock(NULL);
    screen->drawMode = DM_NORMAL;
    screen->show();

/*    sprintf(fname, "rainout/%i.bmp",c++);
    bmpWrite(fname, screen, &pal, 0,0,319,199);
*/
    //screen->fCircle(60,20,10,230); // moon
    screen->blur(0,0, VGA_MAXX, VGA_MAXY);
    screen->move(0,0, VGA_MAXX, VGA_MAXY, move1);
    delay(60);
  } while (!kbhit());
  getch();
#ifndef NOSOUND
  nosound();
#endif

  delete screen;
  crt_restoreVideoMode();
}