#include <stdio.h>
#include <conio.h>
#include <process.h>
#include <dos.h>

#define SCANNER_STATUS_TIMEOUT   0x01
#define SCANNER_STATUS_NOERROR   0x08
#define SCANNER_STATUS_SELECTED  0x10  // if selected and nopaper enabled
#define SCANNER_STATUS_NOPAPER   0x20  // there is no printer attached
#define SCANNER_STATUS_ACK       0x40
#define SCANNER_STATUS_NOTBUSY   0x80

void scanner_init(int iobaseport) {  // 278h, 378h or 3BCh
  unsigned char c = inp(iobaseport+2);
  outp(iobaseport+2, c & 0xFB);
  outp(iobaseport+2, c | 0x04);
}

int scanner_getstatus(int iobaseport) {
  return(inp(iobaseport+1));
}

void printRegs(union REGS *regs) {
  printf("AX: %X\nBX: %X\nCX: %X\nDX: %X\n", regs->x.ax,regs->x.bx,regs->x.cx,regs->x.dx);
}


int main(int argc, char *argv[]) {
  int ret, count;
  unsigned int pport = 0; /* LPT1 selected */
  unsigned int port = peek(0x0040, 0x0008+pport*2);

  argc; argv;

  clrscr();

  ret = inp(0x102);
  outp(0x102, ret | 0x90); // enable bidirectional port

  ret = inp(port+2);
  outp(port+2, ret | 0x20); // enable bidirectional port

  /*scanner_init(port);
  count = 0;
  do { // polling
    delay(200);
    ret = scanner_getstatus(port);
    count++;
  } while (((ret & SCANNER_STATUS_NOTBUSY)!=SCANNER_STATUS_NOTBUSY)&&(count<50));
  if (count >= 50) {
    printf("Timeout!\n");
    exit(1);
  }
  printf("Scanner ready.\n",ret);
  */


  outp(port, 0x1B);
  outp(port, 'G');
  int r = inp(port);

  printf("ret: %X\n", r);
  //outp(port, 'G');

  /*int stat = inp(port+1);
  printf("status: %X\n", stat);*/


  getch();
  return(0);
}