/*
WINDOW class
*/

class Window { // draws windows in text mode
 public:
  Window(short, short, short, short, BYTE);
  ~Window();
  BYTE getColor() { return(color); }
  void show();
 private:
  short x1,y1, x2,y2;
  BYTE color;
  char visible;
  char *back;
};

Window::Window(short x1,short y1, short x2,short y2, BYTE color) {
  this->x1 = x1;
  this->y1 = y1;
  this->x2 = x2;
  this->y2 = y2;
  this->color = color;
  visible = 0;
  back = 0;
}

Window::~Window() {
  if (visible && (back != 0)) {
    puttext(x1+1,y1+1, x2+1,y2+2, back);
    free(back);
  }
}

void Window::show() {
  int i,j;
  back = (char *)malloc(2*(x2-x1+1)*(y2-y1+1));
  gettext(x1+1,y1+1, x2+1,y2+2, back);
  crt_printc(x1,y1, color, '');
  for (i=x1+1; i<x2; i++) crt_printc(i,y1, color, '');
  crt_printc(x2,y1, color, '');
  for (j=y1+1; j<y2; j++) {
    crt_printc(x1,j, color, '');
    for (i=x1+1; i<x2; i++) crt_printc(i,j, color, ' ');
    crt_printc(x2,j, color, '');
  }
  crt_printc(x1,y2, color, '');
  for (i=x1+1; i<x2; i++) crt_printc(i,y2, color, '');
  crt_printc(x2,y2, color, '');
  visible = 1;
}