#pragma warn -inl
#pragma warn -par
#pragma warn -aus
//#pragma option -N

#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <dos.h>


unsigned char far *videoseg = (unsigned char far *) 0xA0000000L;

void putpixel(unsigned int x, unsigned int y, unsigned char color) {
  const vga_width = 320;
  if ((x >= 320)||(y >= 200)) return;
  *(videoseg+y*vga_width+x) = color;
}

void clear(unsigned char color) {
  asm {
    cli
    push es
    push di
    mov  al, color
    mov  ah, al
    les  di, videoseg
    mov  cx, 32000
    rep stosw
    pop  di
    pop  es
    sti
  }
}

void line(unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2, unsigned char color) {
  int dx = x2-x1, dy = y2-y1,
      ix = abs(dx), iy = abs(dy),
      inct = (ix>iy?ix:iy),
      plotX = x1, plotY = y1,
      x = 0, y = 0,
      i;
  unsigned char plot;
  putpixel(plotX,plotY, color);
  for (i=0;i<=inct;i++) {
    x += ix;
    y += iy;
    plot = 0;
    if (x > inct) {
      plot = 1;
      x -= inct;
      if (dx > 0) plotX++;
      if (dx < 0) plotX--;
     }
     if (y > inct) {
       plot = 1;
       y -= inct;
       if (dy > 0) plotY++;
       if (dy < 0) plotY--;
     }
     if (plot) putpixel(plotX,plotY, color);
  }
}
//---------------------------------------------------------------------------
#include <w3d.h>
//---------------------------------------------------------------------------

void main() {
  int i;
  point3Ds cubeP[8] = {{-1,+1,+1}, {+1,+1,+1}, {+1,-1,+1}, {-1,-1,+1},
		       {-1,+1,-1}, {+1,+1,-1}, {+1,-1,-1}, {-1,-1,-1}};
  edge cubeE[12] = {{0,1},{1,2},{2,3},{3,0},{4,5},{5,6},{6,7},{7,4},{0,4},{1,5},{2,6},{3,7}};

  point3Ds axisP[6] = {{-160,0,0},{+160,0,0},{0,-100,0},{0,+100,0},{0,0,-160},{0,0,+160}};
  edge axisE[3] = {{0,1},{2,3},{4,5}};

  point3Ds O = {0.00, 0.00, 0.00};

  point *ph = new point;              // gestori di strutture
  object3D *obj = new object3D(ph);   //
  world3D *w3d = new world3D(obj,"MyWorld");

  ph->parentObj = (obj_p *)obj;
  obj->parentWld = (wld_p *)w3d;

  point3Ds p3d,p3d2;
  edge edg;
  object3Ds axis, cube, floor;

  clrscr();

  obj->init(&cube);
  obj->setName(&cube, "obj_cube");
  for (i=0;i<8;i++) obj->addNode(&cube,cubeP[i]);
  for (i=0;i<12;i++) obj->addEdge(&cube,cubeE[i]);

  obj->init(&axis);
  obj->setName(&cube, "obj_axis");
  for (i=0;i<6;i++) obj->addNode(&axis,axisP[i]);
  for (i=0;i<3;i++) obj->addEdge(&axis,axisE[i]);

  obj->init(&floor);
  obj->setName(&floor, "obj_floor");
  {
  int x,y,z;
  int gridx = w3d->sizeX/20;
  int gridz = w3d->sizeZ/20;
  p3d.y = -w3d->sizeY/2;
  for (i=0,p3d.x=-w3d->sizeX/2;i<gridx;i++,p3d.x+=20) {
    p3d.z = -w3d->sizeZ;
    obj->addNode(&floor, p3d);
    p3d.z = 0;
    obj->addNode(&floor, p3d);
  }
  for (i=0,p3d.z=-w3d->sizeZ;i<gridz;i++,p3d.z+=20) {
    p3d.x = -w3d->sizeX/2;
    obj->addNode(&floor, p3d);
    p3d.x = w3d->sizeX/2;
    obj->addNode(&floor, p3d);
  }
  for (i=0;i<gridx;i++) {
    edg.a = i*2;
    edg.b = i*2+1;
    obj->addEdge(&floor, edg);
  }
  for (i=0;i<gridz;i++) {
    edg.a = i*2+gridx*2;
    edg.b = i*2+1+gridx*2;
    obj->addEdge(&floor, edg);
  }

  }

  w3d->perspective = 1;

  obj->scaleO(&cube,30,30,30);
  object3Ds *ob2 = obj->duplicate(&cube);
  p3d.x = 80;
  p3d.z = 0;
  p3d.y = 50;
  obj->scaleO(ob2, 1,0.2,2);
  obj->move(ob2, p3d);

  w3d->addObj(cube);
  //w3d->addObj(floor);
  w3d->addObj(*ob2);
  w3d->addObj(axis);

  //w3d->sizeZ = 50;

  asm {
    mov  ax, 0x0013
    int  0x10
  }

  p3d.x = 0;
  p3d.z = 1;
  p3d.y = 0;
  i = 0;
  //obj->drawMode = 1;
  while (!kbhit()) {
    w3d->meX = cos((double)i/20)*30;
    w3d->meY = sin((double)i/20)*20;
    //w3d->meZ = sin((double)i/50)*(w3d->sizeZ/2);
    i++;
    obj->rotateO(&cube,0.03,0.03,0.01);
    //obj->move(ob2,p3d);
    //obj->rotateO(ob2,0.01,0.02,0.03);
    w3d->draw();
    delay(10);
    clear(0);  //paLLiative
  }

  getch();
  asm {
    mov  ax, 0x0003
    int  0x10
  }

  delete w3d;
  delete obj;
  delete ph;
}