#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <vga.h>
#include <vgapal.h>
#include <crt.h>
#include <math.h>

#include "bmp.cpp"
char fname[100];
int ct = 0;

#define POINTS    50
#define LEVELS    20
#define STEPS    100

typedef struct {
  short x,y;
} SPOINT;

pal256 pal1;
VirtualScreen *vir1;

SPOINT pts[LEVELS][POINTS];
SPOINT steps[LEVELS][STEPS];

void initPts() {
  register int i,j;
  double rad;
  SPOINT pt;

  for (j=0; j<LEVELS; j++) {
    for (i=0; i<POINTS; i++) {
      rad = LEVELS/2+j*(60/LEVELS)+exp((double)(6.0*j)/LEVELS)/(LEVELS/5);
      pt.x = (short)(cos((i*2*M_PI)/POINTS)*rad+VGA_WIDTH/2);
      pt.y = (short)(sin((i*2*M_PI)/POINTS)*rad+VGA_HEIGHT/2);
      pts[j][i] = pt;
    }
    for (i=0; i<STEPS; i++) {
      pt.x = (short)(cos(2*(i*2*M_PI+j*9)/STEPS)*(VGA_WIDTH/6)*(LEVELS-j)/8);
      pt.y = (short)(sin(3*(i*2*M_PI+j*8)/STEPS)*(VGA_HEIGHT/4)*(LEVELS-j)/8);
      steps[j][i] = pt;
    }
  }
}

int main() {
  int i,j, cl, dim;
  int counter = 0;
  SPOINT pt;

  crt_setVideoMode(0x13);

  vir1 = new VirtualScreen();
  vir1->clear(0);
  pal_setGradient(&pal1, 1,96, 5,10,20, 20,30,50);
  pal_setGradient(&pal1, 97,128, 20,30,50, 55,30,20);
  pal_setGradient(&pal1, 129,210, 55,30,20, 63,63,10);
  pal_setGradient(&pal1, 211,255, 63,63,10, 20,63,15);
  //pal_setRandom(&pal1, 4);
  pal_outAll(&pal1);

  initPts();
  do {
    for (j=0; j<LEVELS; j++) {
      cl = (j<<8)/LEVELS;
      dim = j>>3;
      for (i=0; i<POINTS; i++) {
        pt = pts[j][i];
        pt.x += steps[j][counter%STEPS].x;
        pt.y += steps[j][counter%STEPS].y;
        /*vir1->putPixel(pt.x, pt.y, cl);
        vir1->putPixel(pt.x+1, pt.y, cl);
        vir1->putPixel(pt.x, pt.y+1, cl);
        vir1->putPixel(pt.x+1, pt.y+1, cl);*/
        vir1->fRect(pt.x,pt.y, pt.x+dim,pt.y+dim, cl);
        //vir1->fCircle(pt.x,pt.y, 1, cl);
      }
    }

    vir1->show();

/*    sprintf(fname, "holeout/%i.bmp",ct++);
    bmpWrite(fname, vir1, &pal1, 0,0,319,199);
*/
    vir1->clear(0);
    //vir1->blur(0,0,319,199);
    delay(8);
    counter++;
  } while (!kbhit());
  getch();


  delete vir1;
  crt_restoreVideoMode();
  return(0);
}