#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <mem.h>
#include <io.h>
#include <string.h>

#define MAX_LINE            512
#define COMMENT_DELIMITER   ';'
#define STRING_DELIMITER    '"'
//#define CAT_DELIMITER  "[]"


int readLine(int handle, void *buffer) {
  char *tbuff = (char *)malloc(MAX_LINE+2);
  //tbuff += 2;
  int bread = _read(handle, tbuff, MAX_LINE);
  if (bread == 0) return(-1); // EOF
  *(tbuff+bread) = 0;
  char *cr = strstr(tbuff, "\n");   // don't use on unix files
  if (cr == NULL) {
    memcpy(buffer, tbuff, bread+1);
  } else {
    int nlen = cr-tbuff-1;  // problem! if cr == tbuff??
    memcpy(buffer, tbuff, nlen);
    *((char *)buffer+nlen) = 0;
    lseek(handle,-(bread-nlen-2),SEEK_CUR);
  }
  return(1);
}

void remSpace(char *sStr) {       // !!--BUG!!!!!!!! only space?
  int i, li,lu;
  int sl = strlen(sStr);
  if (sl == 0) return;

  for (i=sl-1; i>=0;i--) {
    if (sStr[i] != ' ') {i++; break;}
  }
  *(sStr+i) = 0;

  /*for (i=0,li=0; i<sl;i++) {
    if (sStr[i] == ' ') li++; else break;
  }

  if (li != lu) {
    memmove(sStr, sStr+li,lu-li+1);
    *(sStr+lu) = 0;
  }*/
}

void remComments(char *sStr) {   // !!--ADD SPECIAL CHARS!
  short int c = 1;
  int i;
  for (i=0;i<strlen(sStr);i++) {
    if ((sStr[i] == COMMENT_DELIMITER)&& c) {
      if (i > 0) i--;
      break;
    }
    if (sStr[i] == STRING_DELIMITER) c ^= 1;
  }
  sStr[i] = 0;
}

int getCat(char *inStr, char *outStr) {
  if ((inStr[0] == '[')&&(inStr[strlen(inStr)-1] == ']')) {
    memcpy(outStr,inStr,strlen(inStr)+1);
    return(1);
  } else return(0);
}

int getItem(char *inStr, char *outStr) {
  if ((inStr[0] == '[')&&(inStr[strlen(inStr)-1] == ']')) {
    memcpy(outStr,inStr,strlen(inStr)+1);
    return(1);
  } else return(0);
}


void main() {
  clrscr();
  char name[] = "TEST.INI";
  char *buffer = (char *)malloc(512);

  int handle = open(name,0);
  if (handle == -1) return;

  memset(buffer,43,200);

  //char *tStr = (char *)malloc(200);
  while (readLine(handle,buffer) != -1) {
    //remSpace(buffer);
    remComments(buffer);
    //remSpace(buffer);
    //if (getCat(buffer, tStr)) printf("%s\n", tStr);
    printf("%s##\n",buffer);
  }

  close(handle);

  getch();
}
