#include <stdio.h>
#include <conio.h>
#include <alloc.h>
#include <crt.h>
#include <vga.h>

struct myChar {
  char code;     // corresponding ASCII code
  int sizeX, sizeY;
  char data[1][1];  // (*data)[]
};

struct myFont {
  int totChars;
  myChar *chars[1];
};

void drawFont(VirtualScreen *virscr, myFont font) {
  int i,j,k;
  virscr->text(10,10,"Only a test: ",1, 2);
  for (k=0;k<font.totChars;k++) {
    for (j=0;j<font.chars[k]->sizeY;j++) {
      for (i=0;i<font.chars[k]->sizeX;i++) {
	virscr->putPixel(0+i+k*20,40+j, font.chars[k]->data[j][i]);
      }
    }
  }
}

void main() {
  int i,j;

  VirtualScreen *vir1 = new VirtualScreen();
  crt_init();
  crt_setVideoMode(0x13);
  vir1->clear(0);
  randomize();

  myChar *data = (myChar *)malloc(5+10*10+2);
  data->code = 'i';
  data->sizeX = 10;
  data->sizeY = 10;

  for (j=0;j<10;j++) {
    for (i=0;i<10;i++) {
      data->data[j][i] = random(256);
    }
  }
  myFont mf = {1,data};

  drawFont(vir1, mf);
  vir1->show();

  getch();
  crt_restoreVideoMode();
  delete vir1;
}