#include <stdio.h>
#include <conio.h>
#include <dos.h>

#define SB_DSP_BASE                0x226;
#define SB_DSP_READ                0x22A;
#define SB_DSP_WRITEBUFFER_STATUS  0x22C;
#define SB_DSP_READBUFFER_STATUS   0x22E;


#pragma warn -rvl
unsigned char Sb_DSP_Read() {
  asm {
    MOV  DX, SB_DSP_READBUFFER_STATUS
  }
  poll:
  asm {
    IN   AL, DX
    TEST AL, 0x80
    JZ   poll
    MOV  DX, SB_DSP_READ
    IN   AL, DX
  }
}
#pragma warn +rvl

void Sb_DSP_Write(unsigned char data) {
  asm {
    MOV  DX, SB_DSP_WRITEBUFFER_STATUS
  }
  poll:
  asm {
    IN   AL, DX
    TEST AL, 0x80
    JNZ  poll
    MOV  AL, data
    OUT  DX, AL
  }
}

void main()
  {
    clrscr();

    printf("start...\n");
    outportb(0x226,1);
    asm nop;
    asm nop;
    asm nop;
    outportb(0x226,0);
    while (!(inportb(0x22E)>>7)) printf("a");
    while (inportb(0x22A)!=0xAA) printf("b");

    //Sb_DSP_Write(3);

    printf("ok");

    getch();
  }