#include <vga.h>
#include <vgapal.h>
#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <crt.h>
#include <math.h>

#include "bmp.cpp"
char fname[100];
int c = 0;


#define SPRITES  60
#define SPRITEX   5
#define SPRITEY   5
#define STEPS   200

typedef struct {
  short x,y;
} SPOINT;

BYTE spr1[SPRITEY][SPRITEX] =
  {0x00,0xE7,0xEF,0xE7,0x00,
   0xE7,0xEF,0xFF,0xEF,0xE7,
   0xEF,0xFF,0xFF,0xFF,0xEF,
   0xE7,0xEF,0xFF,0xEF,0xE7,
   0x00,0xE7,0xEF,0xE7,0x00};

VirtualScreen *vir1;
pal256 pal1;

SPOINT sprs[SPRITES][STEPS];

void initPts() {
  register int i,j;
  SPOINT pt;

  for (j=0; j<SPRITES; j++) {
    for (i=0; i<STEPS; i++) {
      pt.x = (int)(cos(4*(i*2*M_PI+j*4)/STEPS)*(20+sin(3*((j+i)*2.0*M_PI)/(STEPS+SPRITES))*100.0)+VGA_WIDTH/2);
      pt.y = (int)(sin(2*(i*2*M_PI+j*7)/STEPS)*(18+sin(2*(j*2.0*M_PI)/SPRITES)*50.0)+VGA_HEIGHT/2);
      sprs[j][i] = pt;
    }
  }

}

void drawSprite(int x, int y) {
  register int i,j;
  BYTE cl;
  for (j=0; j<SPRITEY; j++) {
    for (i=0; i<SPRITEX; i++) {
      cl = spr1[j][i];
      if (cl != 0) vir1->putPixel(i+x,j+y, cl);
    }
  }
}

void myblur() {
  register int i,j;
  int m, c;
  BYTE far *bufIn = vir1->bufferIn,
       far *bufOut = vir1->bufferOut;

  for (j=0; j<VGA_HEIGHT-4; j++) {
    m = j*VGA_WIDTH;
    bufIn = vir1->bufferIn+m+(j>>5);
    for (i=1; i<VGA_WIDTH-4; i++) {
      //c = 0;
      bufIn++;
      c = *(bufIn+VGA_WIDTH);
      c += *(bufIn+VGA_WIDTH*2-1);
      c += *(bufIn+VGA_WIDTH*2)>>1;
      c += *(bufIn+VGA_WIDTH*2+1);
      c >>= 2;
      *(bufOut+m+i) = c;
    }
  }
}

int main() {

  int i,j;
  int counter = 0;
  SPOINT pt;

  crt_setVideoMode(0x13);

  vir1 = new VirtualScreen();
  vir1->clear(0);
  pal_setGradient(&pal1, 1,127, 5,10,10, 30,60,45);
  pal_setGradient(&pal1, 128,220, 30,60,45, 20,60,25);
  pal_setGradient(&pal1, 221,255, 20,60,25, 55,60,20);
  pal_outAll(&pal1);

  initPts();
  vir1->drawMode = DM_MAX;
  do {
    i = counter%STEPS;
    for (j=0; j<SPRITES; j++) {
      pt = sprs[j][i];
      drawSprite(pt.x,pt.y);
    }

    vir1->show();

/*    sprintf(fname, "spriteou/%i.bmp",c++);
    bmpWrite(fname, vir1, &pal1, 0,0,319,199);
*/
    //vir1->blur(10,10,319-10,199-20);
    myblur();
    //vir1->clear(0);
    //delay(10);
    counter++;
  } while (!kbhit());
  getch();

  delete vir1;
  crt_restoreVideoMode();
  return(0);
}