#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#define VECTORTYPE      int

class vector {
 public:
  vector();
  vector(int size);
  ~vector();
  int getsize();
  void add(VECTORTYPE);

  VECTORTYPE & operator [](int);
  vector & operator =(VECTORTYPE);
  vector & operator =(vector &);
 private:
  VECTORTYPE *data;
  int size;
};

vector::vector() {
  size = 0;
  data = NULL;
}

vector::vector(int size) {
  this->size = size;
  data = (VECTORTYPE*)malloc(size);
  for (int i=0; i<size; i++) *(data+i) = 0;
}

vector::~vector() {
  if (data != NULL) free(data);
}

inline int vector::getsize() {
  return(size);
}

VECTORTYPE & vector::operator [](int index) {
  if (data == NULL) return(*data);
  if ((unsigned)index >= size) index = size-1;
  return(*(data+index));
}

/*void vector::add(VECTORTYPE item) {
}*/

vector & vector::operator =(VECTORTYPE n) {
  for (int i=0; i<size; i++) *(data+i) = n;
  return(*this);
}

vector & vector::operator =(vector &v) {
}
//--------------------------------------------------

int main() {
  int i;

  vector a(3);
  vector b(3)

  b = a;

  a[0] = 5;
  a[1] = 10;
  a[2] = 20;
  b[0] = 45;

  for (i=0; i<a.getsize(); i++) printf("%i ", a[i]);
  for (i=0; i<b.getsize(); i++) printf("%i ", b[i]);


  getc(stdin);
  return(0);
}