/*
  VGA.H 2
*/
#ifndef VGA2_H
#define VGA2_H

//#pragma option -2

/*#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <memory.h>
#include <process.h>
#include <string.h>
*/
#include <alloc.h>

#include <dtypes.h>

// use 32bit operations (only on 386+ processors)
//#define USE_32BIT

#define VGA_WIDTH    320
#define VGA_HEIGHT   200
#define VGA_MAXX     VGA_WIDTH-1
#define VGA_MAXY     VGA_HEIGHT-1

// drawMode constants
#define DM_NONE         0
#define DM_NORMAL       1
#define DM_ADD          2
#define DM_SUB1         3
#define DM_SUB2         4
#define DM_MUL          5
#define DM_AND          6
#define DM_OR           7
#define DM_XOR		8
#define DM_MIN          9
#define DM_MAX         10
#define DM_BLEND50     11
#define DM_BLEND       DM_BLEND50


typedef short VGACOORD;

typedef int near (*VGA_ERRFUNC)(int id, int src);

typedef struct { // 18 bytes
  BYTE  drawMode,
        reserved_align;
  WORD  width,
        height;
  DWORD bufferSize;
  BYTE far *bufferIn,
       far *bufferOut;
} EXTDATA, *PEXTDATA;

extern PEXTDATA _vga_data;
/*extern WORD _vga_width;
extern WORD _vga_height;
extern BYTE _vga_drawMode;
extern DWORD _vga_bufferSize;
extern BYTE far *_vga_screenIn;
extern BYTE far *_vga_screenOut;*/
//extern BYTE far *_vga_segment;

extern "C" {
  int _vga_errHandler(int id, int src);
  void _vga_show();
  void _vga_clear(BYTE color);
  int _vga_putpixel(VGACOORD x, VGACOORD y, BYTE color);
  void _vga_line(VGACOORD x1, VGACOORD y1, VGACOORD x2, VGACOORD y2, BYTE color);
  void _vga_hline(VGACOORD x1, VGACOORD x2, VGACOORD y, BYTE color);
  void _vga_circle(VGACOORD x, VGACOORD y, int rad, BYTE color);
}
/*struct pointS {  // used by ftri()
  int x,y;
};*/

class VirtualScreen2 {
  public:
    /*char drawMode;
    BYTE far *bufferIn,
         far *bufferOut;*/
    VirtualScreen2();
    ~VirtualScreen2();

    void show();
    void clear(BYTE color);

    VGACOORD getWidth() { return(data.width); }
    VGACOORD getHeight() { return(data.height); }
    void setDrawMode(BYTE dm) { data.drawMode = dm; }
    void setBufferIn(BYTE far *buf) { data.bufferIn = buf; }
    void setBufferOut(BYTE far *buf) { data.bufferOut = buf; }

    int putPixel(VGACOORD x, VGACOORD y, BYTE color);
    void line(VGACOORD x1, VGACOORD y1, VGACOORD x2, VGACOORD y2, BYTE color);
    void circle(VGACOORD x, VGACOORD y, int rad, BYTE color);

    //void fTri(VGACOORD x1, VGACOORD y1, VGACOORD x2, VGACOORD y2, VGACOORD x3, VGACOORD y3, BYTE color);
    //void fCircle(VGACOORD x, VGACOORD y, int rad, BYTE color);

    //void blur(VGACOORD x1, VGACOORD y1, VGACOORD x2, VGACOORD y2);
    /*VirtualScreen(VGACOORD, VGACOORD);
    VirtualScreen(VirtualScreen *);

    void restoreBuffers();
    void copyTo(VirtualScreen *virscr);
    void copyTo(VirtualScreen *virscr, VGACOORD, VGACOORD);
    void copyTo(VirtualScreen *virscr, BYTE skipCol);
    void copyRectTo(VirtualScreen *virscr, VGACOORD x1, VGACOORD y1, VGACOORD x2, VGACOORD y2);
    // ?? void copyRect(VirtualScreen *virscr, VGACOORD x1, VGACOORD y1, VGACOORD x2, VGACOORD y2);
    void getRect(VGACOORD x1, VGACOORD y1, VGACOORD x2, VGACOORD y2, BYTE *);
    void putRect(VGACOORD x1, VGACOORD y1, VGACOORD x2, VGACOORD y2, BYTE *);
    // far versions:
    void getRect(VGACOORD x1, VGACOORD y1, VGACOORD x2, VGACOORD y2, BYTE far *);
    void putRect(VGACOORD x1, VGACOORD y1, VGACOORD x2, VGACOORD y2, BYTE far *);

    BYTE getPixel(VGACOORD x, VGACOORD y);
    void rect(VGACOORD x1, VGACOORD y1, VGACOORD x2, VGACOORD y2, BYTE color);
    void fRect(VGACOORD x1, VGACOORD y1, VGACOORD x2, VGACOORD y2, BYTE color);
    void text(VGACOORD x, VGACOORD y, char *data, BYTE size, BYTE color);


    void pixelize(VGACOORD x1, VGACOORD y1, VGACOORD x2, VGACOORD y2, BYTE size);
    void stretch(VGACOORD x1, VGACOORD y1, VGACOORD x2, VGACOORD y2, VGACOORD x3, VGACOORD y3, VGACOORD x4, VGACOORD y4);
    void shiftUp(VGACOORD x1, VGACOORD y1, VGACOORD x2, VGACOORD y2, BYTE offset);
    void move(VGACOORD x1, VGACOORD y1, VGACOORD x2, VGACOORD y2, void transCoord(VGACOORD x,VGACOORD y, VGACOORD *xout,VGACOORD *yout));
    */
  protected:
    EXTDATA data;
    WORD width, height;
    DWORD bufferSize;
    BYTE far *screen;

    VGA_ERRFUNC errHandler;

    void hLine(VGACOORD x1, VGACOORD x2, VGACOORD y, BYTE color);
    /*int checkCoords(VGACOORD *x1, VGACOORD *y1, VGACOORD *x2, VGACOORD *y2);

    int getLowY(pointS pts[3]);      //  \
    int getHighY(pointS pts[3]);     //   > used by ftri()
    void reorderX(pointS (*pts)[]);  //  /
    */
};

VirtualScreen2::VirtualScreen2() {
  errHandler = _vga_errHandler;
  data.drawMode = DM_NORMAL;
  data.width = VGA_WIDTH;
  data.height = VGA_HEIGHT;
  data.bufferSize = (DWORD)width*height;
  screen = (BYTE far *)farmalloc(bufferSize);
  if (screen == NULL) errHandler(1,0);
  data.bufferIn = screen;
  data.bufferOut = screen;
}

VirtualScreen2::~VirtualScreen2() {
  if (screen != NULL) farfree(screen);
}

void VirtualScreen2::show() {
/*  _vga_bufferSize = bufferSize;
  _vga_screenIn = bufferIn;*/
  _vga_data = &data;
  _vga_show();
}

void VirtualScreen2::clear(BYTE color) {
/*  _vga_bufferSize = bufferSize;
  _vga_screenOut = bufferOut;*/
  _vga_data = &data;
  _vga_clear(color);
}

int VirtualScreen2::putPixel(VGACOORD x, VGACOORD y, BYTE color) {
/*  _vga_width = width;
  _vga_height = height;
  _vga_drawMode = drawMode;
  _vga_screenIn = bufferIn;
  _vga_screenOut = bufferOut;*/
  _vga_data = &data;
  return( _vga_putpixel(x,y, color) );
}

void VirtualScreen2::line(VGACOORD x1, VGACOORD y1, VGACOORD x2, VGACOORD y2, BYTE color) {
/*  _vga_width = width;
  _vga_height = height;
  _vga_drawMode = drawMode;
  _vga_screenIn = bufferIn;
  _vga_screenOut = bufferOut;*/
  _vga_data = &data;
  _vga_line(x1,y1, x2,y2, color);
}

void VirtualScreen2::hLine(VGACOORD x1, VGACOORD x2, VGACOORD y, BYTE color) {
/*  _vga_width = width;
  _vga_height = height;
  _vga_drawMode = drawMode;
  _vga_screenIn = bufferIn;
  _vga_screenOut = bufferOut;*/
  _vga_data = &data;
  _vga_hline(x1,x2, y, color);
}

void VirtualScreen2::circle(VGACOORD x, VGACOORD y, int rad, BYTE color) {
/*  _vga_width = width;
  _vga_height = height;
  _vga_drawMode = drawMode;
  _vga_screenIn = bufferIn;
  _vga_screenOut = bufferOut;*/
  _vga_data = &data;
  _vga_circle(x,y, rad, color);
}

/*
VirtualScreen::VirtualScreen(VGACOORD x, VGACOORD y) {
  drawMode = DM_NORMAL;
  width = x;
  height = y;
  bufferSize = (DWORD)width*height;
  screen = (BYTE far *)farmalloc(bufferSize);
  if (screen == NULL) error(0);
  bufferIn = screen;
  bufferOut = screen;
}

VirtualScreen::VirtualScreen(VirtualScreen *virscr) {
  drawMode = DM_NORMAL;
  width = virscr->getWidth();
  height = virscr->getHeight();
  bufferSize = (DWORD)width*height;
  screen = (BYTE far *)farmalloc(bufferSize);
  if (screen == NULL) error(0);
  bufferIn = screen;
  bufferOut = screen;
}

void VirtualScreen::restoreBuffers() {
  bufferIn = screen;
  bufferOut = screen;
}

void VirtualScreen::copyTo(VirtualScreen *virscr) {
  #ifndef USE_32BIT
  _fmemcpy(virscr->screen, bufferIn, bufferSize);
  #else
  void far *scR = bufferIn, far *scW = virscr->screen;
  WORD siz = (bufferSize>>2);
  asm {
    PUSH ES
    PUSH DS
    PUSH DI
    PUSH SI
    DB 0x66; XOR  DI, DI    // xor  edi, edi
    DB 0x66; XOR  SI, SI    // xor  esi, esi
    DB 0x66; XOR  CX, CX    // xor  ecx, ecx
    LES  DI, scW
    LDS  SI, scR
    MOV  CX, siz
    DB 0x66; REP  MOVSW     // rep movsd
    POP  SI
    POP  DI
    POP  DS
    POP  ES
  }
  #endif
}

void VirtualScreen::copyTo(VirtualScreen *virscr, VGACOORD x, VGACOORD y) {
// copies actual screen to virscr, at pos x,y
  register int j;
  int dimx, dimy, bound,
      inx,iny, sizx,sizy;
  BYTE far *bufIn, far *bufOut;

  inx = (x<0)?-x:0;
  iny = (y<0)?-y:0;
  sizx = width-inx;
  sizy = height-iny;
  bound = x+inx+sizx-virscr->getWidth();
  dimx = sizx-((bound<0)?0:bound);
  bound = y+iny+sizy-virscr->getHeight();
  dimy = sizy-((bound<0)?0:bound);

  bufIn = bufferIn+iny*width+inx;
  bufOut = virscr->bufferOut+(y+iny)*virscr->getWidth()+x+inx;
  for (j=0; j<dimy; j++) {
    _fmemcpy(bufOut, bufIn, dimx);
    bufOut += virscr->getWidth();
    bufIn += width;
  }
}

void VirtualScreen::copyTo(VirtualScreen *virscr, BYTE skipCol) {
  void far *scR = bufferIn, far *scW = virscr->screen;
  WORD siz = bufferSize;
  asm {
    PUSH ES
    PUSH DS
    PUSH DI
    PUSH SI
    LES  DI, scW
    LDS  SI, scR
    MOV  CX, siz
    MOV	 AH, skipCol
  } skipLoop: asm {
    LODSB
    CMP	 AH, AL
    JNE  skip
    INC  DI
    JMP	 contLoop
  } skip: asm {
    STOSB
  } contLoop: asm {
    LOOP skipLoop
    POP  SI
    POP  DI
    POP  DS
    POP  ES
  }
}

void VirtualScreen::copyRectTo(VirtualScreen *virscr, VGACOORD x1, VGACOORD y1, VGACOORD x2, VGACOORD y2) {
  VGACOORD j, p;
  if (!checkCoords(&x1,&y1,&x2,&y2)) return;
  for (j=y1;j<=y2;j++)
    for (p=x1;p<=x2;p++) virscr->putPixel(p,j, *(bufferIn+j*width+p));
}

void VirtualScreen::getRect(VGACOORD x1, VGACOORD y1, VGACOORD x2, VGACOORD y2, BYTE *buffer) {
  VGACOORD j, c=0;
  if (!checkCoords(&x1,&y1,&x2,&y2)) return;
  for (j=y1;j<=y2;j++) {
    _fmemcpy(buffer+c, bufferIn+j*width+x1, x2-x1+1);
    c += x2-x1+1;
  }
}

void VirtualScreen::putRect(VGACOORD x1, VGACOORD y1, VGACOORD x2, VGACOORD y2, BYTE *buffer) {
  VGACOORD j, p, c, l;
  if (!checkCoords(&x1,&y1,&x2,&y2)) return;
  if (drawMode == DM_NORMAL) { // fast!!
    l = abs(x2-x1+1);
    for (j=y1,c=0,p=y1*width+x1; j<=y2; j++,p+=width,c+=l)
      _fmemcpy(screen+p, buffer+c, l);
  } else {
    for (j=y1;j<=y2;j++)
      for (p=x1;p<=x2;p++) putPixel(p,j, *(buffer+c++));
  }
}

// far versions
void VirtualScreen::getRect(VGACOORD x1, VGACOORD y1, VGACOORD x2, VGACOORD y2, BYTE far *buffer) {
  VGACOORD j, c=0;
  if (!checkCoords(&x1,&y1,&x2,&y2)) return;
  for (j=y1;j<=y2;j++) {
    _fmemcpy(buffer+c, bufferIn+j*width+x1, x2-x1+1);
    c += x2-x1+1;
  }
}

void VirtualScreen::putRect(VGACOORD x1, VGACOORD y1, VGACOORD x2, VGACOORD y2, BYTE far *buffer) {
  VGACOORD j, p, c, l;
  if (!checkCoords(&x1,&y1,&x2,&y2)) return;
  if (drawMode == DM_NORMAL) { // fast!!
    l = abs(x2-x1+1);
    for (j=y1,c=0,p=y1*width+x1; j<=y2; j++,p+=width,c+=l)
      _fmemcpy(screen+p, buffer+c, l);
  } else {
    for (j=y1;j<=y2;j++)
      for (p=x1;p<=x2;p++) putPixel(p,j, *(buffer+c++));
  }
}

BYTE VirtualScreen::getPixel(VGACOORD x, VGACOORD y) {
  if ((x<0)||(y<0)||(x>=width)||(y>=height)) return(0);
  return( *(bufferIn+y*width+x) );
}

void VirtualScreen::rect(VGACOORD x1, VGACOORD y1, VGACOORD x2, VGACOORD y2, BYTE color) {
  if (!checkCoords(&x1,&y1,&x2,&y2)) return;
  line(x1,y1,x2,y1, color);
  line(x1,y1,x1,y2, color);
  line(x2,y1,x2,y2, color);
  line(x1,y2,x2,y2, color);
}

void VirtualScreen::fRect(VGACOORD x1, VGACOORD y1, VGACOORD x2, VGACOORD y2, BYTE color) {
  VGACOORD j, p;
  if (!checkCoords(&x1,&y1,&x2,&y2)) return;
  if (drawMode == DM_NORMAL) {
    for (j=y1,p=y1*width+x1; j<=y2; j++,p+=width)  // fast!!
      _fmemset(screen+p, color, abs(x2-x1+1));
  } else {
    for (j=y1;j<=y2;j++)
      for (p=x1;p<=x2;p++) putPixel(p,j,color);
  }
}

void VirtualScreen::fCircle(VGACOORD x, VGACOORD y, int rad, BYTE color) {
  int nx, ny;
  long i, j;
  long r2 = rad*rad+rad;
  for (j=0;j<=rad;j++)
    for (i=0;i<=rad;i++) {
      nx = i+x;  ny = j+y;
      if (j*j+i*i<r2) {
        putPixel(nx,ny,color);
        if (i > 0) {
          putPixel(x-i,ny,color);
          if (j > 0) putPixel(x-i,y-j,color);
        }
        if (j > 0) putPixel(nx,y-j,color);
      }
    }
}

void VirtualScreen2::fTri(VGACOORD x1, VGACOORD y1, VGACOORD x2, VGACOORD y2, VGACOORD x3, VGACOORD y3, BYTE color) {
// 287 processor needed!
  int xmax,ymax, xmed,ymed, xmin,ymin;

  if (y1 > y2) {
    ymax = y2;
    xmax = x2;
    y2 = y1;
    x2 = x1;
    y1 = ymax;
    x1 = xmax;
  }
  if (y1 > y3) {
    ymax = y2;
    xmax = x2;
    ymed = y1;
    xmed = x1;
    ymin = y3;
    xmin = x3;
  } else {
    ymax = y3;
    xmax = x3;
    ymed = y2;
    xmed = x2;
    ymin = y1;
    xmin = x1;
  }

  int dinc1,dinc2, xinc1,xinc2, yinc1, yinc2;
  int d, deltax, deltay, len, x, y;

  int rdinc1,rdinc2, rxinc1,rxinc2, ryinc1, ryinc2;
  int rd, rdeltax, rdeltay, rlen, rx, ry;

  int tdinc1,tdinc2, txinc1,txinc2, tyinc1, tyinc2;
  int td, tdeltax, tdeltay, tlen, tx, ty;

  deltax = abs(xmed-xmin);
  deltay = abs(ymed-ymin);
  d = 0x0001;
  if (deltax >= deltay) {
    d = 0x0100;
    len = deltax;
    deltax = deltay;
    deltay = len;
  }
  xinc1 = d >> 8;
  yinc1 = d & 1;
  xinc2 = 1;  yinc2 = 1;
  len = deltay+1;
  dinc1 = deltax*2;
  dinc2 = (deltax-deltay)*2;
  d = deltax*2 - deltay;
  if (xmin > xmed) {
    xinc1 = -xinc1;
    xinc2 = -xinc2;
  }
  if (ymin > ymed) {
    yinc1 = -yinc1;
    yinc2 = -yinc2;
  }
  x = xmin;
  y = ymin;

  rdeltax = abs(xmax-xmin);
  rdeltay = abs(ymax-ymin);
  rd = 0x0001;
  if (rdeltax >= rdeltay) {
    rd = 0x0100;
    rlen = rdeltax;
    rdeltax = rdeltay;
    rdeltay = rlen;
  }
  rxinc1 = rd >> 8;
  ryinc1 = rd & 1;
  rxinc2 = 1;  ryinc2 = 1;
  rlen = rdeltay+1;
  rdinc1 = rdeltax*2;
  rdinc2 = (rdeltax-rdeltay)*2;
  rd = rdeltax*2 - rdeltay;
  if (xmin > xmax) {
    rxinc1 = -rxinc1;
    rxinc2 = -rxinc2;
  }
  if (ymin > ymax) {
    ryinc1 = -ryinc1;
    ryinc2 = -ryinc2;
  }
  rx = xmin;
  ry = ymin;

  tdeltax = abs(xmax-xmed);
  tdeltay = abs(ymax-ymed);
  td = 0x0001;
  if (tdeltax >= tdeltay) {
    td = 0x0100;
    tlen = tdeltax;
    tdeltax = tdeltay;
    tdeltay = tlen;
  }
  txinc1 = td >> 8;
  tyinc1 = td & 1;
  txinc2 = 1;  tyinc2 = 1;
  tlen = tdeltay+1;
  tdinc1 = tdeltax*2;
  tdinc2 = (tdeltax-tdeltay)*2;
  td = tdeltax*2 - tdeltay;
  if (xmed > xmax) {
    txinc1 = -txinc1;
    txinc2 = -txinc2;
  }
  if (ymed > ymax) {
    tyinc1 = -tyinc1;
    tyinc2 = -tyinc2;
  }
  tx = xmed;
  ty = ymed;

  int i,j;
  i = len;
  j = rlen;
  while ((i >= 0)&&(j >= 0)) {
    if (i >= 0) putPixel(x,y, color);
    if (j >= 0) putPixel(rx,ry, color);
    //hLine(x,rx, y, color*2);
    hLine(rx,x, ry, color*2);
    if (d<0) {
      while (d < 0) {
      d += dinc1;
      x += xinc1;
      y += yinc1;
      }
    } else {
      d += dinc2;
      x += xinc2;
      y += yinc2;
    }
    if (rd<0) {
      rd += rdinc1;
      rx += rxinc1;
      ry += ryinc1;
    } else {
      rd += rdinc2;
      rx += rxinc2;
      ry += ryinc2;
    }
    i--;
    j--;
  }

  //line(x1,y1, x2,y2, color*2);
  //line(x2,y2, x3,y3, color*2);
  //line(x1,y1, x3,y3, color*2);

  int a,b,c, t,k = 0;
  int x,y;
  float q[5],m[5];
  pointS pts[5], tl,br;

  pts[0].x = x1; pts[0].y = y1;
  pts[1].x = x2; pts[1].y = y2;
  pts[2].x = x3; pts[2].y = y3;
  reorderX(&pts);
  pts[3] = pts[0];
  pts[4] = pts[1];
  tl.x = pts[0].x; tl.y = pts[getLowY(pts)].y;
  br.x = pts[2].x; br.y = pts[getHighY(pts)].y;

  for (x=0;x<3;x++) {
    if (pts[x+1].x == pts[x].x) { k = 2+x; continue; }
    asm {
      push  di
      push  si
      lea   si, pts
      lea   di, m
      mov   bx, x
      shl   bx, 1
      shl   bx, 1
    }
    __emit__(0x9B,0xDB,0xE3); // finit
    asm {
      //m[x] = (float)(pts[x+1].y-pts[x].y)/(pts[x+1].x-pts[x].x);
      fild  word ptr [si+bx+4+0]  // x
      fisub word ptr [si+bx+0]
      fild  word ptr [si+bx+4+2]  // y
      fisub word ptr [si+bx+2]
      fdiv  st, st(1)
      fst   dword ptr [di+bx]
      //q[x] = pts[x].y-m[x]*pts[x].x;
      fild  word ptr [si+bx]
      fmul  dword ptr [di+bx]
      fchs
      fiadd word ptr [si+bx+2]
      lea   si, q
      fst   dword ptr [si+bx]
      pop   si
      pop   di
    }
    //if ((k == 0)&&(m[x] == 0)) k = 1;
  }
  asm {
    //m[3] = m[0];  m[4] = m[1];
    //q[3] = q[0];  q[4] = q[1];
    push  si
    push  di
    push  ds
    pop   es
    lea   di, m
    mov   si, di
    add   di, 4*3
    mov   cx, (4*2) shr 1
    rep   movsw
    lea   di, q
    mov   si, di
    add   di, 4*3
    mov   cx, (4*2) shr 1
    rep   movsw
    pop   di
    pop   si
  }

  if (k >= 2) { // vertical!
    k -= 2;
    t = 2;
  } else {
    k = 1;
    __emit__(0x9B,0xDB,0xE3); // finit
    asm {
      push  di
      lea   di, m
      fld   dword ptr [di]
      fcom  dword ptr [di+1*4]
    }
    __emit__(0xDF,0xE0); // fstsw ax
    asm {
      pop   di
      mov   t, 0x0000
      and   ax, 0100010100000000b
      cmp   ax, 0000000100000000b
      je    t1
      cmp   ax, 0100000000000000b
      je    t1
      jmp   t2
    }
    t1: t = 1;
    t2:
  }

  for (y=tl.y;y<=br.y;y++) {
    for (x=tl.x;x<=br.x;x++) {
      asm {
	push  si
	push  di
	mov   bx, k
	shl   bx, 1
        shl   bx, 1
	lea   si, q
	lea   di, m
      }
      __emit__(0x9B,0xDB,0xE3); // finit
      asm {
	fild  x
	fmul  dword ptr [di+bx+2*4]
	fadd  dword ptr [si+bx+2*4]
	fisub y
	fist  a
	fild  x
	fmul  dword ptr [di+bx]
	fadd  dword ptr [si+bx]
	fisub y
	fist  b
	fild  x
	fmul  dword ptr [di+bx+1*4]
	fadd  dword ptr [si+bx+1*4]
	fisub y
	fist  c
	pop  di
	pop  si
      }
      switch (t) {
	case 0: {
	  a = (a >= 0);  b = (b >= 0);  c = (c <= 0);
	  break;
	}
	case 1: {
	  a = (a <= 0);  b = (b <= 0);  c = (c >= 0);
	  break;
	}
	case 2: {
	  a = (a <= 0);  b = 1;  c = (c >= 0);
	  break;
	}
      }
      if (a && b && c) putPixel(x,y, color);
    }
  }

}


void VirtualScreen::text(VGACOORD x, VGACOORD y, char *data, BYTE size, BYTE color) {
  int i,j,k;
  BYTE chr;
  static BYTE far *charTab = 0;
  if (charTab == 0) {
    asm {
      push  es
      push  bp
      mov   ax, 0x1130
      mov   bh, 0x06
      int   0x10
      mov   word [charTab], bp   // only if static
      mov   word [charTab+2], es
      pop   bp
      pop   es
    }
  }
  for (i=0;i<strlen(data);i++) {
    for (j=0;j<16;j++) {
      chr = *(charTab+(BYTE)data[i]*16+j);
      for (k=0;k<8;k++) {
	asm ROL chr, 1;
	if (chr & 0x01)
	  if (size>1) fRect(x+k*size+i*8*size,y+j*size,x+k*size+i*8*size+size-1,y+j*size+size-1,color); else
	    putPixel(x+k+i*8,y+j,color);
      }
    }
  }
}

void VirtualScreen2::blur(VGACOORD x1, VGACOORD y1, VGACOORD x2, VGACOORD y2) {
  BYTE b1,b2,b3,b4;
  int c,m;
  BYTE far *scrI;
  register int i, j;
  //if (!checkCoords(&x1,&y1,&x2,&y2)) return;
  j = y1;
  scrI = bufferIn+j*width+x1;
  m = j*width;
  for (i=x1;i<=x2;i++) {              // 1st line
    b2 = ((i==x1) ? 0 : *(scrI-1));
    b3 = ((i>=x2) ? 0 : *(scrI+1));
    b4 = *(scrI+width);
    c = b2+b3+b4;
    *(bufferOut+m+i) = c >> 2;
    scrI++;
  }
  for (j=y1;j<y2;j++) {
    scrI = bufferIn+j*width+x1;
    m = (j+1)*width;
    for (i=x1;i<=x2;i++) {
      b1 = *scrI;
      b2 = ((i==x1) ? 0 : *(scrI+width-1));
      b3 = ((i>=x2) ? 0 : *(scrI+width+1));
      b4 = ((j>=y2-1) ? 0 : *(scrI+(width<<1)));
      c = b1+b2+b3+b4;
      *(bufferOut+m+i) = c >> 2;
      scrI++;
    }
  }
}

void VirtualScreen::pixelize(VGACOORD x1, VGACOORD y1, VGACOORD x2, VGACOORD y2, BYTE size) {
  int i,j;
  BYTE tcol;
  if (!checkCoords(&x1,&y1,&x2,&y2)||size<2) return;
  for (j=y1;j<=y2;j += size)
    for (i=x1;i<=x2;i += size) {
      tcol = *(bufferIn+j*width+i);
      fRect(i,j,i+size-1,j+size-1,tcol);
    }
}

void VirtualScreen::stretch(VGACOORD x1, VGACOORD y1, VGACOORD x2, VGACOORD y2, VGACOORD x3, VGACOORD y3, VGACOORD x4, VGACOORD y4) {
  BYTE tcol;
  unsigned int i,j, k,l;
  if (!checkCoords(&x1,&y1,&x2,&y2)) return;
  l = y1;
  for (j=y3;j<y4;j++) {
    k = x1;
    for (i=x3;i<x4;i++) {
      tcol = *(bufferIn+l*width+k);
      putPixel(i,j,tcol);
      k = (long)(i-x3)*(x2-x1)/(x4-x3)+x1;
    }
    l = (j-y3)*(y2-y1)/(y4-y3)+y1;
  }
}

void VirtualScreen::shiftUp(VGACOORD x1, VGACOORD y1, VGACOORD x2, VGACOORD y2, BYTE offset) {
  int i,j;
  if (!checkCoords(&x1,&y1,&x2,&y2)) return;
  for (j=y1;j<=y2-offset;j++) {
    _fmemcpy(bufferOut+j*width+x1, bufferIn+(j+offset)*width+x1, x2-x1);
  }
}

#pragma option -w-ccc
void VirtualScreen::move(VGACOORD x1, VGACOORD y1, VGACOORD x2, VGACOORD y2, void transCoord(VGACOORD x,VGACOORD y, VGACOORD *xout,VGACOORD *yout)) {
  VGACOORD i,j, xn,yn;
  if (!checkCoords(&x1,&y1,&x2,&y2)) return;
  for (j=y1;j<=y2;j++) {
    for (i=x1;i<=x2;i++) {
      BYTE color;
      transCoord(i,j, &xn,&yn);
      if ((xn<0)||(yn<0)||(xn>=width)||(yn>=height))
	//{xn %= VGA_WIDTH; yn %= VGA_HEIGHT; }
	{ color = 0;}
      else
	color = *(bufferIn+yn*width+xn);
      putPixel(i,j, color);
    }
  }
}
#pragma option -w+ccc

int VirtualScreen2::getLowY(pointS pts[3]) {
  int i, a = 0;
  for (i=1;i<3;i++) if (pts[a].y > pts[i].y) a = i;
  return a;
}

int VirtualScreen2::getHighY(pointS pts[3]) {
  int i, a = 0;
  for (i=1;i<3;i++) if (pts[a].y < pts[i].y) a = i;
  return a;
}

void xchg(pointS *a, pointS *b) {
  asm {
    push  si
    push  di
    mov   si, a
    mov   di, b
    mov   ax, [si]
    mov   dx, [si+2]
    xchg  [di],ax
    xchg  [di+2],dx
    mov   [si], ax
    mov   [si+2], dx
    pop   di
    pop   si
  }
}

void VirtualScreen2::reorderX(pointS (*pts)[]) {
  int i, j;
  for (j=0;j<2;j++) {
    for (i=0;i<2;i++) {
      if ((*pts)[i].x >= (*pts)[i+1].x) {
	if ((*pts)[i].x == (*pts)[i+1].x) {
	  if ((*pts)[i].y > (*pts)[i+1].y) xchg(&(*pts)[i+1], &(*pts)[i]);
	} else xchg(&(*pts)[i+1], &(*pts)[i]);
      }
    }
  }
}

int VirtualScreen2::checkCoords(VGACOORD *x1, VGACOORD *y1, VGACOORD *x2, VGACOORD *y2) {
  VGACOORD t;
  order(x1,x2);
  order(y1,y2);
  if (*x1<0) *x1 = 0;
  if (*y1<0) *y1 = 0;
  if (*x2>=width) *x2 = width-1;
  if (*y2>=height) *y2 = height-1;
  if ((*x1>=width)||(*y1>=height)||(*x2<0)||(*y2<0)) return(0);
  return(1);
}
*/
//---------------------------------------------------------------------------
#endif